//////////////////////////////////////////
//
// NOTE: This is *not* a valid shader file
//
///////////////////////////////////////////
Shader "Bakery/Skybox" {
    Properties {
        _Tint ("Tint Color", Color) = (0.5,0.5,0.5,0.5)
        _Exposure ("Exposure", Float) = 1
        _MatrixRight ("Right", Vector) = (1,0,0,0)
        _MatrixUp ("Up", Vector) = (0,1,0,0)
        _MatrixForward ("Forward", Vector) = (0,0,1,0)
        _Tex ("Cubemap   (HDR)", Cube) = "white" { }
        _NoTexture ("No texture", Float) = 0
        _Hemispherical ("Hemispherical", Float) = 0
    }
    SubShader {
        Tags { "PreviewType" = "Skybox" "QUEUE" = "Background" "RenderType" = "Background" }
        Pass {
            Tags { "PreviewType" = "Skybox" "QUEUE" = "Background" "RenderType" = "Background" }
            ZWrite Off
            Cull Off
            GpuProgramID 22006
            PlayerProgram "vp" {
                SubProgram "gles3 " {
                    "#ifdef VERTEX
                    #version 300 es
                    
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	vec4 hlslcc_mtx4x4unity_ObjectToWorld[4];
                    uniform 	vec4 hlslcc_mtx4x4unity_MatrixVP[4];
                    uniform 	vec3 _MatrixRight;
                    uniform 	vec3 _MatrixUp;
                    uniform 	vec3 _MatrixForward;
                    uniform 	vec4 hlslcc_mtx4x4reflection2World[4];
                    in highp vec4 in_POSITION0;
                    out highp vec3 vs_TEXCOORD0;
                    vec4 u_xlat0;
                    vec4 u_xlat1;
                    void main()
                    {
                        u_xlat0.x = dot(_MatrixUp.xyz, in_POSITION0.xyz);
                        u_xlat0 = u_xlat0.xxxx * hlslcc_mtx4x4unity_ObjectToWorld[1];
                        u_xlat1.x = dot(_MatrixRight.xyz, in_POSITION0.xyz);
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[0] * u_xlat1.xxxx + u_xlat0;
                        u_xlat1.x = dot(_MatrixForward.xyz, in_POSITION0.xyz);
                        u_xlat0 = hlslcc_mtx4x4unity_ObjectToWorld[2] * u_xlat1.xxxx + u_xlat0;
                        u_xlat0 = u_xlat0 + hlslcc_mtx4x4unity_ObjectToWorld[3];
                        u_xlat1 = u_xlat0.yyyy * hlslcc_mtx4x4unity_MatrixVP[1];
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[0] * u_xlat0.xxxx + u_xlat1;
                        u_xlat1 = hlslcc_mtx4x4unity_MatrixVP[2] * u_xlat0.zzzz + u_xlat1;
                        gl_Position = hlslcc_mtx4x4unity_MatrixVP[3] * u_xlat0.wwww + u_xlat1;
                        u_xlat0.xyz = in_POSITION0.yyy * hlslcc_mtx4x4reflection2World[1].xyz;
                        u_xlat0.xyz = hlslcc_mtx4x4reflection2World[0].xyz * in_POSITION0.xxx + u_xlat0.xyz;
                        vs_TEXCOORD0.xyz = hlslcc_mtx4x4reflection2World[2].xyz * in_POSITION0.zzz + u_xlat0.xyz;
                        return;
                    }
                    
                    #endif
                    #ifdef FRAGMENT
                    #version 300 es
                    
                    precision highp float;
                    precision highp int;
                    #define HLSLCC_ENABLE_UNIFORM_BUFFERS 1
                    #if HLSLCC_ENABLE_UNIFORM_BUFFERS
                    #define UNITY_UNIFORM
                    #else
                    #define UNITY_UNIFORM uniform
                    #endif
                    #define UNITY_SUPPORTS_UNIFORM_LOCATION 1
                    #if UNITY_SUPPORTS_UNIFORM_LOCATION
                    #define UNITY_LOCATION(x) layout(location = x)
                    #define UNITY_BINDING(x) layout(binding = x, std140)
                    #else
                    #define UNITY_LOCATION(x)
                    #define UNITY_BINDING(x) layout(std140)
                    #endif
                    uniform 	mediump vec4 _Tex_HDR;
                    uniform 	mediump vec4 _Tint;
                    uniform 	mediump float _Exposure;
                    uniform 	float _NoTexture;
                    uniform 	float _Hemispherical;
                    UNITY_LOCATION(0) uniform mediump samplerCube _Tex;
                    in highp vec3 vs_TEXCOORD0;
                    layout(location = 0) out mediump vec4 SV_Target0;
                    vec4 u_xlat0;
                    bool u_xlatb0;
                    vec4 u_xlat1;
                    mediump vec3 u_xlat16_2;
                    mediump vec3 u_xlat16_3;
                    mediump float u_xlat16_14;
                    void main()
                    {
                        u_xlatb0 = _NoTexture<0.5;
                        u_xlat1 = texture(_Tex, vs_TEXCOORD0.xyz);
                        u_xlat0 = (bool(u_xlatb0)) ? u_xlat1 : vec4(1.0, 1.0, 1.0, 1.0);
                        u_xlat16_2.x = u_xlat0.w + -1.0;
                        u_xlat16_2.x = _Tex_HDR.w * u_xlat16_2.x + 1.0;
                        u_xlat16_2.x = log2(u_xlat16_2.x);
                        u_xlat16_2.x = u_xlat16_2.x * _Tex_HDR.y;
                        u_xlat16_2.x = exp2(u_xlat16_2.x);
                        u_xlat16_2.x = u_xlat16_2.x * _Tex_HDR.x;
                        u_xlat16_2.xyz = u_xlat0.xyz * u_xlat16_2.xxx;
                        u_xlat16_2.xyz = u_xlat16_2.xyz * _Tint.xyz;
                        u_xlat16_2.xyz = u_xlat16_2.xyz * vec3(_Exposure);
                        u_xlatb0 = vs_TEXCOORD0.y<0.0;
                        u_xlat16_14 = (u_xlatb0) ? 0.0 : 1.0;
                        u_xlat16_3.xyz = vec3(u_xlat16_14) * u_xlat16_2.xyz;
                        u_xlatb0 = 0.0<_Hemispherical;
                        SV_Target0.xyz = (bool(u_xlatb0)) ? u_xlat16_3.xyz : u_xlat16_2.xyz;
                        SV_Target0.w = 1.0;
                        return;
                    }
                    
                    #endif
                    "
                }
            }
        }
    }
}